#include "setsparse.hpp"
#include <iostream>

using namespace Set;

int main(){

  static const unsigned int size = 10;

  SetSparse s(size);
  
  if (s.is_empty())
    std::cout << "set is empty" << std::endl;
  
  s.set(3);
  if (s.contains(3))
    std::cout << "contains 3" << std::endl;

  s.set(5);
  if (s.contains(5))
    std::cout << "contains 5" << std::endl;

  s.set(6);
  if (s.contains(6))
    std::cout << "contains 6" << std::endl;

  if (s.contains(6))
    {std::cout << "set[6]=" << s[6] << std::endl;}

  std::cout << "set is " << s << std::endl;
  std::cout << "set has #elements=" << s.cardinality() << std::endl;

  s.unset(3);

  std::cout << "set has #elements=" << s.cardinality() << std::endl;
  std::cout << "set is " << s << std::endl;

  SetSparse s2(size);
  s2.set(1);
  s2.set(0);
  s2.set(3);
  s2.set(6);

  std::cout << "set s2 is=" << s2 << std::endl;

  SetSparse s3(size);
  SetSparse s4(size);

  set_intersect(s, s2, s3);
  std::cout << "set intersection(s1, s2) is s3=" << s3 << std::endl;

  set_union(s, s2, s4);
  std::cout << "set intersection(s1, s2) is s4=" << s4 << std::endl;

  SetSparse s5(s4);
  std::cout << "s5(s4) s5=" << s5 << std::endl;

  SetSparse s6(size);
  s6 = s4;
  std::cout << "s6=s4 s6=" << s6 << std::endl;

  s4 = s4;
  std::cout << "s4=s4 s4=" << s4 << std::endl;
}
